<template>
  <div>
    <div @click="openToggle">
      <slot></slot>
    </div>
    <a-modal v-model="isToggleActive" centered :footer="null" :width="1100" :closeable="false">
      <div class="relative mb-8">
        <div class="absolute">
          <b-outline-action-button @click="closeToggle">Back</b-outline-action-button>
        </div>
        <div class="text-center">
          <t-h1 size="text-3xl" weight="bold">Personal Information</t-h1>
        </div>
      </div>
      <div class="text-center mb-6">
        <a-radio-group v-model="tab" button-style="solid">
          <a-radio-button value="general">General</a-radio-button>
          <a-radio-button value="history">History</a-radio-button>
          <a-radio-button value="nearby">Nearby</a-radio-button>
        </a-radio-group>
      </div>
      <div v-if="tab === 'general'" class="p-12 py-10">
        <lookup-general-person-tab :passenger="passenger"></lookup-general-person-tab>
      </div>
      <div v-if="tab === 'history'" class="p-12 py-10">
        <lookup-historical-person :passenger="passenger"></lookup-historical-person>
      </div>
      <div v-if="tab === 'nearby'" class="p-12 py-10">
        <lookup-nearby-person :passenger="passenger"></lookup-nearby-person>
      </div>
    </a-modal>
  </div>
</template>

<script lang="ts">
import { defineComponent } from '@nuxtjs/composition-api'
import TH1 from '~/components/shared/typography/H1.vue'
import BOutlineActionButton from '~/components/shared/buttons/OutlineActionButton.vue'
import { IPassengerItem } from '~/contracts'
import useSharedToggle from '~/composables/useSharedToggle'
import LookupGeneralPersonTab from '~/components/lookup/LookupGeneralPersonTab.vue'
import LookupHistoricalPerson from '~/components/lookup/LookupHistoricalPerson.vue'
import LookupNearbyPerson from '~/components/lookup/LookupNearbyPerson.vue'

export default defineComponent({
  components: {
    LookupGeneralPersonTab,
    LookupHistoricalPerson,
    LookupNearbyPerson,
    BOutlineActionButton,
    TH1,
  },
  props: {
    passenger: {
      type: Object as () => IPassengerItem,
      required: true
    },
  },
  setup() {
    return { ...useSharedToggle() }
  },
  data() {
    return {
      tab: 'general',
    }
  },
})
</script>
